// -----------------------------------------------------------
// BSServerSocket.java
// -----------------------------------------------------------
package cz.vutbr.wsagent.bscomm;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * Class <code>BSServerSocket</code> allows creating sockets and listening on given port
 * to receive messages from other programs. 
 * @author Martin Gábor
 */
public class BSServerSocket {

    private ServerSocket server = null;
    private Socket socket = null;
    private ObjectInputStream objectInputStream;

    /**
     * The constructor for creating new connection with given socket port.
     * @param port Port of socket.
     */
    public BSServerSocket(int port) throws IOException {

        server = new ServerSocket(port);

    }


    /**
     * Listen method.
     * @return Returns the request message.
     */
    public String Listen() {
        String message = null;
        try {
            // New Connection accept
            socket = server.accept();

            // Read a message sent by client application
            objectInputStream = new ObjectInputStream(socket.getInputStream());
            try {
                message = (String) objectInputStream.readObject();
            } catch (ClassNotFoundException ex) {
            }

        } catch (IOException e) {
            e.printStackTrace();
        }
        return message;
    }

    /**
     * Listen method.
     * @param message The content of message to be returned.
     */
    public void sendResponse(String message) {
        //
        // Send a response information to the client application
        //
        ObjectOutputStream objectOutputStream = null;
        try {
            objectOutputStream = new ObjectOutputStream(socket.getOutputStream());
            objectOutputStream.writeObject(message);

            // close input
            objectInputStream.close();
            // close output
            objectOutputStream.close();
            // close socket
            socket.close();
        } catch (IOException ex) {
        }
    }
}
