// -----------------------------------------------------------
// MessageParser.java
// -----------------------------------------------------------

package cz.vutbr.wsagent.bscomm;

import cz.vutbr.wsagent.comm.AgentMessage;


/**
 * This class is for parsing messages under communication protocol.
 * @author Martin Gábor
 */
public class MessageParser implements InternalCommProtocol{


    /**
     * Returns true if the message is agent message.
     * @param message Given message.
     * @return Returns true if the message is agent type of message.
     */
    public boolean isMessageAgent(String message){

        String[] messageArray = message.split(DIVIDER);
        if(messageArray[0].compareTo(TYPE_AGENT) == 0)
            return true;
        else
            return false;
    }

    public boolean isRefreshMessage(String message) {

        String[] messageArray = message.split(DIVIDER);
        if(messageArray[0].compareTo(TYPE_REFRESH) == 0)
            return true;
        else
            return false;
    }

    /**
     * Returns agent message.
     * @param message Given message.
     * @return Returns agent message.
     */
    public Messenger getAgentParsed(String message){

        // new wagon
        Messenger messenger = new Messenger();
        System.out.println("Message : "+ message );
	System.out.println(" ############################ ");

        // split up the message
        String[] messageArray = message.split(DIVIDER,-1);

        // set address
        messenger.setAddress(Integer.valueOf(messageArray[1]));


        // create new agent
        AgentMessage agent = new AgentMessage();

        agent.setPlanBase(messageArray[2]);
        agent.setPlan(messageArray[3]);
        agent.setBeliefBase(messageArray[4]);
        agent.setInputBase(messageArray[5]);
        agent.setAgentId(Long.valueOf(messageArray[6]));
	agent.setClassId(Long.valueOf(messageArray[7]));

        messenger.setMessage(agent);
        

        return messenger;
    }

    /**
     * Returns simple message.
     * @param message Given message.
     * @return Returns simple message.
     */
    public Messenger getMessageParsed(String message){

        // new wagon
        Messenger messenger = new Messenger();

        // String M/A, String message;
        String[] messageArray = message.split(DIVIDER,-1);

        messenger.setAddress(Integer.valueOf(messageArray[1]));
        messenger.setMessage(messageArray[2]);
        
        return messenger;
    }

    public Messenger getRefreshMessageParsed(String message) {

        Messenger messenger = new Messenger();
        
        // String M/A, String message;
        String[] messageArray = message.split(DIVIDER,-1);

        messenger.setAddress(Integer.valueOf(messageArray[1]));

        return messenger;
    }
}
