// -----------------------------------------------------------
// DbConnFactory.java
// -----------------------------------------------------------

package cz.vutbr.wsagent.db.hibernate;


import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;


/**
 * Hibernate Utility class with a convenient method to get Session Factory object.
 *
 * @author Martin Gábor
 */
public class DbConnFactory {

private static SessionFactory sessionFactory = null;

  /**
   * Returns session current factory.
   */
  public static SessionFactory getSessionFactory() {
    if (sessionFactory == null) {
      initSessionFactory();
    }
    return sessionFactory;
  }

  /**
   * Initializes new Session factory.
   */
  private static synchronized void initSessionFactory() {
    sessionFactory = new Configuration().configure().buildSessionFactory();
  }

  /**
   * Returns actual session.
   */
  public static Session getSession() {
    return getSessionFactory().getCurrentSession();
  }

}
