// -----------------------------------------------------------
// IDAOFactory.java
// -----------------------------------------------------------

package cz.vutbr.wsagent.entity;


/**
 * The abstract factory class for getting DAO objects.
 * @author Martin Gábor
 */
public interface IDAOFactory {

    /**
     * Returns IAgentDAO object.
     */
     IAgentDAO getAgentDAO();
    /**
     * Returns ISettingDAO object.
     */
     ISettingDAO getSettingDAO();

    /**
     * Returns IMoteDAO object.
     */
     IMoteDAO getMoteDAO();

    /**
     * Returns IMessageDAO object.
     */
     IMessageDAO getMessageDAO();
}
